#property copyright "Copyright  2008, TrendLaboratory"
#property link      "http://finance.groups.yahoo.com/group/TrendLaboratory"

#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 LightBlue
#property indicator_color2 Tomato
#property indicator_color3 LightBlue
#property indicator_color4 Tomato

extern double RangePercent = 33.0;
double g_ibuf_84[];
double g_ibuf_88[];
double g_ibuf_92[];
double g_ibuf_96[];

int init() {
   SetIndexStyle(0, DRAW_HISTOGRAM);
   SetIndexBuffer(0, g_ibuf_84);
   SetIndexStyle(1, DRAW_HISTOGRAM);
   SetIndexBuffer(1, g_ibuf_88);
   SetIndexStyle(2, DRAW_HISTOGRAM);
   SetIndexBuffer(2, g_ibuf_92);
   SetIndexStyle(3, DRAW_HISTOGRAM);
   SetIndexBuffer(3, g_ibuf_96);
   string ls_0 = "RangeBar(" + RangePercent + ")";
   IndicatorShortName(ls_0);
   SetIndexLabel(0, "Up Bar");
   SetIndexLabel(1, "Down Bar");
   SetIndexLabel(2, "Up Body");
   SetIndexLabel(3, "Down Body");
   return (0);
}

int start() {
   int li_4;
   double ld_16;
   int l_ind_counted_8 = IndicatorCounted();
   if (l_ind_counted_8 < 0) return (-1);
   if (l_ind_counted_8 == 0) li_4 = Bars - 1;
   if (l_ind_counted_8 < 1) {
      for (int li_12 = Bars - 1; li_12 >= 0; li_12--) {
         g_ibuf_84[li_12] = EMPTY_VALUE;
         g_ibuf_88[li_12] = EMPTY_VALUE;
         g_ibuf_92[li_12] = EMPTY_VALUE;
         g_ibuf_96[li_12] = EMPTY_VALUE;
      }
   }
   if (l_ind_counted_8 > 0) li_4 = Bars - l_ind_counted_8;
   li_4--;
   for (int li_0 = li_4; li_0 >= 0; li_0--) {
      if (RangePercent > 0.0) {
         ld_16 = (High[li_0] - Low[li_0]) * RangePercent / 100.0;
         if (High[li_0] - Close[li_0] < ld_16 && Open[li_0] - Low[li_0] < ld_16) {
            g_ibuf_84[li_0] = High[li_0];
            g_ibuf_88[li_0] = Low[li_0];
            g_ibuf_92[li_0] = Close[li_0];
            g_ibuf_96[li_0] = Open[li_0];
         } else {
            if (Close[li_0] - Low[li_0] < ld_16 && High[li_0] - Open[li_0] < ld_16) {
               g_ibuf_84[li_0] = Low[li_0];
               g_ibuf_88[li_0] = High[li_0];
               g_ibuf_92[li_0] = Close[li_0];
               g_ibuf_96[li_0] = Open[li_0];
            } else {
               g_ibuf_84[li_0] = EMPTY_VALUE;
               g_ibuf_88[li_0] = EMPTY_VALUE;
               g_ibuf_92[li_0] = EMPTY_VALUE;
               g_ibuf_96[li_0] = EMPTY_VALUE;
            }
         }
      }
   }
   return (0);
}